program gal_checker;

{$APPTYPE CONSOLE}
{$R+}

uses 
  testlib;

const 
  eps = 0.001;
  maxn = 200000;

var
  n, i: integer;
  x, y, z: array[0..maxn] of extended;
  mx, my, mz, xd, yd, zd, xj, yj, zj, vpx, vpy, vpz, vpa, cxy, cxz, cyz: extended;

begin
  
  mx := 0; my := 0; mz := 0;
  cxy := 0; cxz := 0; cyz := 0;

  n := inf.readinteger();
  for i := 1 to n do
  begin
    x[i] := inf.readreal;
    y[i] := inf.readreal;
    z[i] := inf.readreal;
    mx := mx + x[i];
    my := my + y[i];
    mz := mz + z[i];
  end;

  for i := 1 to n do
  begin
    cxy := cxy + (x[i] - mx / n) * (y[i] - my / n) / n;
    cxz := cxz + (x[i] - mx / n) * (z[i] - mz / n) / n;
    cyz := cyz + (y[i] - my / n) * (z[i] - mz / n) / n;
  end;

  xd := ouf.readreal;
  yd := ouf.readreal;
  zd := ouf.readreal;

  xj := ans.readreal;
  yj := ans.readreal;
  zj := ans.readreal;

  vpx := yj * zd - zj * yd;
  vpy := - xj * zd + zj * xd;
  vpz := xj * yd - yj * xd;

  vpa := sqrt(sqr(vpx) + sqr(vpy) + sqr(vpz));

  if (vpa < eps) then
    quit(_ok, 'Participant vector is collinear with one of jury')
  else
  begin
    if (abs(cxy) < eps) and (abs(cxz) < eps) and (abs(cyz) < eps) then
      quit(_ok, 'Participant vector is NOT collinear with one of jury, but covariance matrix is diagonal')
    else
      quit(_wa, 'Participant vector is NOT collinear with one of jury and covariance matrix is NOT diagonal');
  end;

end.
